
//---------------浮窗图表--------------
var fChart_ = (function () {
    var fChart_ = {};
    fChart_.data = {};

    fChart_.initChart = {};//是否初始化

    //图表切换
    fChart_.switchChart = function (elem) {

        var t;
        if (!elem) t = $('#cft-menu>.atv');
        else t = $(elem);
        var type = t.attr('data-ct');
        if (elem && t.hasClass('atv')) return;

        t.addClass('atv').siblings('.atv').removeClass('atv');
        $('#cft-chartBox>.cft-cb[data-ct="' + type + '"]').addClass('atv').siblings('.atv').removeClass('atv');

        if (!fChart_.initChart[type]) {

            fChart_.initChart[type] = true;

            if (type == 'min') {
                fChart_.reqFMChartData(fChart_.sid);
            }
            else {
                fChart_.reqFKChartData(fChart_.sid, true);
            }
        }
    };

    //请求分时图
    fChart_.reqFMChartData = function (sid) {

        var box = $('#floatMChart');

        box.html($_.GetLoadTip('loading', { va: true }));

        var Data;
        var stockType;//股票类型
        

        if (sid.indexOf('8') == 0) {
            //板块
            stockType = 'plate';
            Data = { c: 'PCArrangeData', a: 'GetZSHQPlate', SelType: 1, PStockID: sid, PlateID: sid };
        }
        else {
            //个股
            stockType = 'stock';
            Data = { c: 'StockL2Data', a: 'GetStockTrend', StockID: sid };
        }

        $_.ajax({
            url: $_.reqUrl4,
            data: Data,
            suc: function (Json) {

                $_.GetLoadTip('loading', { va: true, box: box });

                var JD = stockType == 'plate' ? Json.trend : Json;

                if (!JD) {
                    JD = {
                        preclose_px: 0,
                        hprice: 0,
                        lprice: 0,
                        trend: []
                    };
                }

                var data = {
                    yp: parseFloat(JD.preclose_px),// 昨收价
                    date: (function () {
                        var d = [];
                        if (JD.day) {
                            d.push(JD.day.substr(0, 4));
                            d.push(JD.day.substr(4, 2));
                            d.push(JD.day.substr(6));
                        }
                        return d.join('-');
                    })(),
                    list: JD.trend
                };

                fChart_.mChart = new floatMChart(box, {
                    data: data,
                    stockType: stockType,
                    hasAvg: stockType == 'plate' ? false : true //是否存在均线
                });

            },
            berro: function (Json) {
                box.append($_.GetLoadTip('reload', { va: true, box: box, tip: Json.errmsg, attr: 'onclick="fChart_.reqFMChartData(\'' + sid + '\')"' }));
            },
            err: function () {
                box.append($_.GetLoadTip('reload', { va: true, box: box, attr: 'onclick="fChart_.reqFMChartData(\'' + sid + '\')"' }));
            }
        });

    };

    //请求k线图
    fChart_.reqFKChartData = function (sid, isLoading) {

        var box = $('#floatKChart');
        var chart = fChart_.kChart;

        if (!chart || isLoading) {
            isLoading = true;
            box.append($_.GetLoadTip('loading', { va: true, box: box }));
        }

        var reqTotal = 1;//请求次数
        var chartData = {
            x: [],//时间
            k: [],//k线
            vol: {
                l: [],//成交量
                e: []  //成交额
            }
        };
        var st = 400;

        //绘图
        var darwChart = function () {
            reqTotal--;
            if (reqTotal > 0) return;

            if (isLoading) $_.GetLoadTip('loading', { va: true, box: box });

            if (!chart) {
                fChart_.kChart = new floatKChart_(box, {
                    data: chartData,
                    kType: 'd'
                });
            }
            else {
                chart.setData(chartData);
                chart.DrawOverall('redraw');
            }
        };

        //错误事件
        var err = function (Par) {

            if (chart || !isLoading) return;

            var LT = { va: true, tip: Par.errmsg, attr: 'onclick="fChart_.reqFKChartData(\'' + sid + '\')"', box: box };
            if (Par) LT.tip = Par.errmsg;

            box.append($_.GetLoadTip('reload', LT));
        };

        //请求k线数据
        (function () {
            var Data, url;
            var stockType;//股票类型

            if (sid.indexOf('8') == 0) {
                //板块
                stockType = 'plate';
                url = $_.reqUrl5;
                Data = { c: 'ZhiShuKLine', a: 'GetPlateKLineDay', StockID: sid, Index: 0, st: st, Type: 'd' };
            }
            else {
                //个股
                stockType = 'stock';
                url = $_.reqUrl5;
                Data = { c: 'StockLineData', a: 'GetKLineDay', StockID: sid, Index: 0, st: st };
            }


            $_.ajax({
                url: url,
                data: Data,
                suc: function (Json) {

                    //计算均线、指数指标
                    (function () {
                        var len = Json.y.length;

                        //初始化
                        (function () {
                            Json.m5 = [];
                            Json.m10 = [];
                            Json.m20 = [];
                            Json.m30 = [];
                        })();

                        for (var i = 0; i < len; i++) {
                            var td1 = Json.y[i];

                            var avg_5 = NaN,
                                avg_10 = NaN,
                                avg_20 = NaN,
                                avg_30 = NaN,
                                avg_sum = 0;

                            var mDay_close = [],
                                avg_m = NaN;

                            var max_min = [];

                            var detNum = (function () {
                                var maxLen = 30;
                                return i - maxLen;
                            })();
                            for (var j = i; j > detNum; j--) {
                                var td2 = Json.y[j];
                                if (j < 0 || !td2) break;

                                //求和（对应天数）
                                avg_sum += td2[1];
                                if (j == i - 4) avg_5 = avg_sum;
                                if (j == i - 9) avg_10 = avg_sum;
                                if (j == i - 19) avg_20 = avg_sum;
                                if (j == i - 29) avg_30 = avg_sum;
                            }

                            //均线
                            Json.m5.push(avg_5 / 5);
                            Json.m10.push(avg_10 / 10);
                            Json.m20.push(avg_20 / 20);
                            Json.m30.push(avg_30 / 30);
                        }

                    })();

                    chartData.x = Json.x;
                    chartData.k = Json.y;
                    chartData.vol = {
                        l: Json.vol,
                        e: Json.bal
                    };
                    chartData.m5 = Json.m5;
                    chartData.m10 = Json.m10;
                    chartData.m20 = Json.m20;
                    chartData.m30 = Json.m30;

                    darwChart();
                },
                berro: function (Json) {
                    err(Json);
                },
                err: function () {
                    err();
                }
            });
        })();

    };

    //请求分时图（小）
    fChart_.reqSFMChartData = function (sid, name) {

        var box = $('#floatMChart_s');

        box.html($_.GetLoadTip('loading', { va: true }));

        var Data = { c: 'StockL2Data', a: 'GetStockTrend', StockID: sid };

        $_.ajax({
            url: $_.reqUrl4,
            data: Data,
            suc: function (Json) {

                $_.GetLoadTip('loading', { va: true, box: box });
                var JD = Json;

                if (!JD) {
                    JD = {
                        preclose_px: 0,
                        hprice: 0,
                        lprice: 0,
                        trend: []
                    };
                }

                var data = {
                    yp: parseFloat(JD.preclose_px),// 昨收价
                    hp: parseFloat(JD.hprice),//最高价
                    lp: parseFloat(JD.lprice),//最低价格
                    date: (function () {
                        var d = [];
                        if (JD.day) {
                            d.push(JD.day.substr(0, 4));
                            d.push(JD.day.substr(4, 2));
                            d.push(JD.day.substr(6));
                        }
                        return d.join('-');
                    })(),
                    name: name,
                    code: sid,
                    list: JD.trend
                };

                fChart_.mChart = new floatMChart_small(box, {
                    data: data
                });

            },
            berro: function (Json) {
                box.append($_.GetLoadTip('reload', { va: true, box: box, tip: Json.errmsg, attr: 'onclick="fChart_.reqSFMChartData(\'' + sid + '\')"' }));
            },
            err: function () {
                box.append($_.GetLoadTip('reload', { va: true, box: box, attr: 'onclick="fChart_.reqSFMChartData(\'' + sid + '\')"' }));
            }
        });


    };

    //请求是否自选
    fChart_.reqIsAddUSto = function () {

        var bon = $('#cfloat-win .cft-head>.addBon');

        bon.attr('data-fb', 1);

        bon.append($_.GetLoadTip('loading', { va: true, tip: '', box: bon }));


        Data = { c: 'PCArrangeData', a: 'GetHQPlate', StockID: fChart_.sid, SelType: 7 };
        $_.ajax({
            url: $_.reqUrl4,
            data: Data,
            suc: function (Json) {

                if (Json.selval == 0) {
                    bon.attr('data-hasadd', 0).attr('data-fb', 0).html('添加自选').attr('onclick', 'fChart_.addDelUSto(this,\'add\')');
                }
                else {
                    bon.attr('data-hasadd', 1).attr('data-fb', 0).html('删除自选').attr('onclick', 'fChart_.addDelUSto(this,\'del\')');
                }
            },
            berro: function (Json) {
                bon.append($_.GetLoadTip('reload', { va: true, box: bon, tip: '', attr: 'onclick="fChart_.reqIsAddUSto()"' }));
            },
            err: function (Json) {
                bon.append($_.GetLoadTip('reload', { va: true, box: bon, tip: '', attr: 'onclick="fChart_.reqIsAddUSto()"' }));
            }
        });

    };

    //添加、删除自选
    fChart_.addDelUSto = function (elem, op) {

        //op 'add' 'del'

        var bon = $(elem);

        bon.append($_.GetLoadTip('loading', { va: true, tip: '', box: bon }));

        var cb = {
            succ: function () {
                if (op == 'del') {
                    bon.attr('data-hasadd', 0).attr('data-fb', 0).html('添加自选').attr('onclick', 'fChart_.addDelUSto(this,\'add\')');
                }
                else {
                    bon.attr('data-hasadd', 1).attr('data-fb', 0).html('删除自选').attr('onclick', 'fChart_.addDelUSto(this,\'del\')');
                }
            },
            berro: function () {
                $_.GetLoadTip('loading', { va: true, tip: '', box: bon });
            },
            err: function () {
                $_.GetLoadTip('loading', { va: true, tip: '', box: bon });
            }
        };


        if (window.ustock_) {
            ustock_.ustockOption(op, fChart_.sid, cb);
        }
        else {

            $_.ajax({
                url: $_.reqUrl + (op == 'add' ? '/api/user/addstock' : '/api/user/delstock'),
                data: { code: fChart_.sid },
                suc: cb.succ,
                berro: cb.berro,
                err: cb.err
            });

        }

    };

    //初始化结构
    fChart_.initStu = function () {

        var h = '<div class="cfloat-win" id="cfloat-win">' +
                '    <div class="cft-body">' +
                '        <div class="arowbar rightAB"><div></div></div>' +
                '        <div class="cft-head">' +
                '            <div class="sname">股票名称</div>' +
                '            <ul id="cft-menu">' +
                '                <li data-ct="min" class="atv" onclick="fChart_.switchChart(this)">分时</li>' +
                '                <li data-ct="d" onclick="fChart_.switchChart(this)">日K</li>' +
                '            </ul>' +
                '            <div class="addBon" data-fb="1">添加自选</div>' +
                '        </div>' +
                '        <div class="cft-box" id="cft-chartBox">' +
                '            <div data-ct="min" class="cft-cb atv">' +
                '                <div id="floatMChart"></div>' +
                '            </div>' +
                '            <div data-ct="d" class="cft-cb">' +
                '                <div id="floatKChart"></div>' +
                '            </div>' +
                '        </div>' +
                '    </div>' +
                '</div>';

        $('#cfloat-win').remove();
        $('body').append(h);
    };

    return fChart_;
})();

$(function () {
    fChart_.initStu();
});

//鼠标停留股票显示走势浮窗
$(document).on('mouseenter', '.over-chart[data-ct]', function (e) {

    var t = $(this),
        chartType = t.attr('data-ct'),
        dlog;//浮窗

    if (chartType == 'big') {
        dlog = $('#cfloat-win');
    }
    else if (chartType == 'small') {
        dlog = $('#cfloat-win-sm');
    }
    else {
        return;
    }

    
    window.clearTimeout(fChart_.OVC_st);
    window.clearTimeout(fChart_.OVC_st2);

    var name = t.attr('data-name'),
        sid = t.attr('data-sid');

    if (!sid) return;

    if (fChart_.data.checkSid == sid) {
        window.clearTimeout(fChart_.OVC_st2);
        if (dlog.is(':visible')) return;
    }
    else {
        dlog.hide();
    }

    fChart_.data.checkSid = sid;

    //定位
    (function () {

        var tW = t.width(),//选中对象宽
            tH = t.height(),
            wobj = $(window),
            winW = wobj.width(),//窗口宽
            winH = wobj.height(),
            scrollTop = 0,//选中对象的所有父对象滚动高度（除窗口外）
            scrollLeft = 0,
            winSCTop = wobj.scrollTop(),//窗口滚动高度
            winSCLeft = wobj.scrollLeft();

        //计算滚动
        (function () {
            var tElem = t[0];
            while (tElem) {
                var QE = $(tElem);
                scrollTop += QE.scrollTop();
                scrollLeft += QE.scrollLeft();
                tElem = tElem.parentNode;
            }
            //减去窗口滚动
            scrollTop -= winSCTop * 2;
            scrollLeft -= winSCLeft * 2;
        });

        var aroW,//箭头宽
            aroH,
            fwinW,//浮窗宽
            fwinH,
            defTH;//箭头与浮窗的默认偏离高度

        (function () {
            if (chartType == 'big') {
                aroW = 15;
                aroH = 24;
                fwinW = 460;
                fwinH = 280;
                defTH = 60;
            }
            else if (chartType == 'small') {
                aroW = 15;
                aroH = 24;
                fwinW = 280;
                fwinH = 145;
                defTH = 60;
            }
        })();

        //var oLeft = $_.getOffset.left(t[0]) - scrollLeft,//选中对象与窗口的距离
        //    oTop = $_.getOffset.top(t[0]) - scrollTop;

        var oLeft = e.clientX - e.offsetX,//选中对象与窗口的距离
            oTop = e.clientY - e.offsetY;

        var fw_rw = fwinW + aroW;//浮窗所需占宽
        var mid_Top = oTop + tH / 2,//对象中间位置
            o_left = oLeft,//左边位置
            o_right = oLeft + tW;//右边位置

        //可用空间
        var sp_left = o_left,
            sp_right = winW - o_right;

        var fw_HP,//浮窗左右位置
            fw_left,//浮窗左偏移
            fw_top;//浮窗上偏移

        //定位
        (function () {
            if (sp_right >= sp_left) {
                //位于右侧
                fw_HP = 'right';
                fw_left = o_right + aroW;
            }
            else {
                fw_HP = 'left';
                fw_left = o_left - aroW - fwinW;
            }

            if (winH >= fwinH) {
                //窗口高度满足
                fw_top = mid_Top - defTH;

                var wbDiff = winH - fwinH,
                    defTsp = 10;//位置空余，浮窗与窗口最小间距
                if (wbDiff < defTsp * 2) defTsp = wbDiff / 2;

                if (fw_top < defTsp) fw_top = defTsp;
                else if (fw_top > ((winH) - fwinH - defTsp)) fw_top = (winH) - fwinH - defTsp;
            }
            else {
                fw_top = 0;
            }

            //浮窗不能高于或低于选中对象
            var aTwTop = aroH / 2 + 4;//低于选中对象偏离浮窗的最小距离
            if (fw_top > mid_Top - aTwTop) fw_top = mid_Top - aTwTop;
            else if ((fw_top + fwinH) < (mid_Top + aTwTop)) fw_top = mid_Top + aTwTop - fwinH;

            var arowbar = dlog.find('.arowbar');
            if (fw_HP == 'left') arowbar.addClass('rightAB');
            else arowbar.removeClass('rightAB');
            arowbar.children('div').css({ "margin-top": (mid_Top - fw_top - aroH / 2) + 'px' });

            dlog.css({
                top: fw_top + 'px',
                left: fw_left + 'px'
            });

            dlog.find('.sname').html(name);
            
        })();

    })();

    fChart_.OVC_st = setTimeout(function () {

        dlog.show();

        //请求数据
        (function () {

            if (chartType == 'big') {
                fChart_.sid = sid;
                fChart_.initChart = {};
                fChart_.switchChart();
                //请求是否自选
                fChart_.reqIsAddUSto();
            }
            else if (chartType == 'small') {
                fChart_.reqSFMChartData(sid, name);
            }

        })();
    }, 350);

}).on('mouseleave', '.over-chart', function () {
    fChart_.OVC_st2 = setTimeout(function () {
        window.clearTimeout(fChart_.OVC_st);
        $('#cfloat-win,#cfloat-win-sm').hide();
    }, 50);
});

$(document).on('mouseover', '#cfloat-win,#cfloat-win-sm', function () {
    window.clearTimeout(fChart_.OVC_st2);
}).on('mouseleave', '#cfloat-win,#cfloat-win-sm', function () {
    //return;

    $(this).hide();
});